#include "MyCPUTime.h"

#pragma once
#pragma warning(disable : 4996)

#include <stdio.h>

MyCPUTime::MyCPUTime() {
}

MyCPUTime::~MyCPUTime() {
}

void MyCPUTime::Start() {
  start = clock();
}

void MyCPUTime::Stop() {
  finish = clock();
  duration = (double)(finish - start) / CLOCKS_PER_SEC;
}

double MyCPUTime::GetEllapsedCPUTime() {
  return duration;
}

void MyCPUTime::WriteEllapsedCPUToFile(char* FName) {
  FILE* f = fopen(FName, "wt");

  fprintf(f, "Elappsed CPU time = %3.5f secunds \n", duration);
  fclose(f);
}
