package gemma;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public interface Cpp {

  public static class ref<T> {
    public T item;

    public ref(T item) {
      this.item = item;
    }
  }

  public default void printf(String s, Object... values) {
    System.out.printf(s.replace("%0.", "%."), values);
  }

  public default <T> T scanf(Class<T> target) {
    try {
      BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
      if (Integer.class.equals(target)) {
        return target.cast(Integer.valueOf(in.readLine()));
      }
    } catch (IOException e) {
      e.printStackTrace();
    }

    return null;
  }

  public default void strcpy(StringBuffer dst, StringBuffer src) {
    dst.append(src);
  }
}
