package gemma;

import java.util.Vector;

public class MatToVec {
  private int H, W;
  private Vector<Vector<Integer>> M;
  private Vector<Vector<Integer>> T;
  private Vector<Integer> V;
  private Vector<Integer> Y;

  public void SetMatrix(Vector<Vector<Integer>> mat) {
    M = mat;
    W = (int) M.size();
    H = (int) M.get(0).size();
  }

  public void ScanLine() {
    V = new Vector<Integer>();
    V.setSize(W * H);
    int x, y;
    int i = 0;
    for (y = 0; y < H; y++) {
      for (x = 0; x < W; x++) {
        V.set(i++, M.get(x).get(y));
      }
    }
  }

  public Vector<Integer> ReturnVector() {
    return V;
  }

  public void SetVector(Vector<Integer> vec) {
    Y = vec;
  }
}
