package gemma;

import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.io.File;
import java.io.IOException;
import java.util.Vector;

import javax.imageio.ImageIO;

public class RawImageData implements Cpp {
  public static final String PATH_TO_IMAGES = "./bmp/";
  public static final int NO_OF_IMAGES = 32;
  public static final int NO_OF_BATCH_IMAGES = 32;

  private StringBuffer[] ImageName = new StringBuffer[NO_OF_BATCH_IMAGES];
  private StringBuffer[] BatchImageName = new StringBuffer[NO_OF_BATCH_IMAGES];

  private int ImageIndex;
  private int W;
  private int H;
  private Vector<Vector<Integer>> InputImageData;
  private int BatchIndex = 0;

  private String lastLoaded;

  public String GetLastLoaded() {
    return lastLoaded;
  }

  public int SelectImage() {
    printf(" 1...Baboon................... 17...Maltese\n");
    printf(" 2...Ballons...................18...Man\n");
    printf(" 3...Barb......................19...Mango\n");
    printf(" 4...Barbara...................20...Mercury\n");
    printf(" 5...Bark......................21...Monarch\n");
    printf(" 6...Board.....................22...Mosaic\n");
    printf(" 7...Boats.....................23...Mushrooms\n");
    printf(" 8...Cameraman.................24...Parrots\n");
    printf(" 9...Earth.....................25...Pens\n");
    printf("10...Flower....................26...Peppers\n");
    printf("11...Flowers...................27...Rainier\n");
    printf("12...Fruits....................28...Sailing\n");
    printf("13...Girl......................29...Sun\n");
    printf("14...Gold......................30...Sunrise\n");
    printf("15...Lena......................31...Yachts\n");
    printf("16...Malamute..................32...Zelda\n");
    printf(" 0...Batch\n");
    printf("99...Exit\n");

    ImageIndex = scanf(Integer.class);

    if (ImageIndex == 99) {
      return ImageIndex;
    }

    // BATCH
    if (ImageIndex == 0) {
      for (int i = 0; i < NO_OF_BATCH_IMAGES; i++) {
        BatchImageName[i] = new StringBuffer();
      }

      StringBuffer S = new StringBuffer();
      strcpy(BatchImageName[0], GetPathAndName(S, "Baboon.bmp"));
      strcpy(BatchImageName[1], GetPathAndName(S, "Balloons.bmp"));
      strcpy(BatchImageName[2], GetPathAndName(S, "Barb.bmp"));
      strcpy(BatchImageName[3], GetPathAndName(S, "Barbara.bmp"));
      strcpy(BatchImageName[4], GetPathAndName(S, "Bark.bmp"));
      strcpy(BatchImageName[5], GetPathAndName(S, "Board.bmp"));
      strcpy(BatchImageName[6], GetPathAndName(S, "Boats.bmp"));
      strcpy(BatchImageName[7], GetPathAndName(S, "Cameraman.bmp"));
      strcpy(BatchImageName[8], GetPathAndName(S, "Earth.bmp"));
      strcpy(BatchImageName[9], GetPathAndName(S, "Flower.bmp"));
      strcpy(BatchImageName[10], GetPathAndName(S, "Flowers.bmp"));
      strcpy(BatchImageName[11], GetPathAndName(S, "Fruits.bmp"));
      strcpy(BatchImageName[12], GetPathAndName(S, "Girl.bmp"));
      strcpy(BatchImageName[13], GetPathAndName(S, "Gold.bmp"));
      strcpy(BatchImageName[14], GetPathAndName(S, "Lena.bmp"));
      strcpy(BatchImageName[15], GetPathAndName(S, "Malamute.bmp"));
      strcpy(BatchImageName[16], GetPathAndName(S, "Maltese.bmp"));
      strcpy(BatchImageName[17], GetPathAndName(S, "Man.bmp"));
      strcpy(BatchImageName[18], GetPathAndName(S, "Mango.bmp"));
      strcpy(BatchImageName[19], GetPathAndName(S, "Mercury.bmp"));
      strcpy(BatchImageName[20], GetPathAndName(S, "Monarch.bmp"));
      strcpy(BatchImageName[21], GetPathAndName(S, "Mosaic.bmp"));
      strcpy(BatchImageName[22], GetPathAndName(S, "Mushrooms.bmp"));
      strcpy(BatchImageName[23], GetPathAndName(S, "Parrots.bmp"));
      strcpy(BatchImageName[24], GetPathAndName(S, "Pens.bmp"));
      strcpy(BatchImageName[25], GetPathAndName(S, "Peppers.bmp"));
      strcpy(BatchImageName[26], GetPathAndName(S, "Rainier.bmp"));
      strcpy(BatchImageName[27], GetPathAndName(S, "Sailing.bmp"));
      strcpy(BatchImageName[28], GetPathAndName(S, "Sun.bmp"));
      strcpy(BatchImageName[29], GetPathAndName(S, "Sunrise.bmp"));
      strcpy(BatchImageName[30], GetPathAndName(S, "Yacht.bmp"));
      strcpy(BatchImageName[31], GetPathAndName(S, "Zelda.bmp"));

      return ImageIndex;
    }

    ImageIndex--;
    for (int i = 0; i < NO_OF_IMAGES; i++) {
      ImageName[i] = new StringBuffer();
    }

    StringBuffer S = new StringBuffer();
    strcpy(ImageName[0], GetPathAndName(S, "Baboon.bmp"));
    strcpy(ImageName[1], GetPathAndName(S, "Balloons.bmp"));
    strcpy(ImageName[2], GetPathAndName(S, "Barb.bmp"));
    strcpy(ImageName[3], GetPathAndName(S, "Barbara.bmp"));
    strcpy(ImageName[4], GetPathAndName(S, "Bark.bmp"));
    strcpy(ImageName[5], GetPathAndName(S, "Board.bmp"));
    strcpy(ImageName[6], GetPathAndName(S, "Boats.bmp"));
    strcpy(ImageName[7], GetPathAndName(S, "Cameraman.bmp"));
    strcpy(ImageName[8], GetPathAndName(S, "Earth.bmp"));
    strcpy(ImageName[9], GetPathAndName(S, "Flower.bmp"));
    strcpy(ImageName[10], GetPathAndName(S, "Flowers.bmp"));
    strcpy(ImageName[11], GetPathAndName(S, "Fruits.bmp"));
    strcpy(ImageName[12], GetPathAndName(S, "Girl.bmp"));
    strcpy(ImageName[13], GetPathAndName(S, "Gold.bmp"));
    strcpy(ImageName[14], GetPathAndName(S, "Lena.bmp"));
    strcpy(ImageName[15], GetPathAndName(S, "Malamute.bmp"));
    strcpy(ImageName[16], GetPathAndName(S, "Maltese.bmp"));
    strcpy(ImageName[17], GetPathAndName(S, "Man.bmp"));
    strcpy(ImageName[18], GetPathAndName(S, "Mango.bmp"));
    strcpy(ImageName[19], GetPathAndName(S, "Mercury.bmp"));
    strcpy(ImageName[20], GetPathAndName(S, "Monarch.bmp"));
    strcpy(ImageName[21], GetPathAndName(S, "Mosaic.bmp"));
    strcpy(ImageName[22], GetPathAndName(S, "Mushrooms.bmp"));
    strcpy(ImageName[23], GetPathAndName(S, "Parrots.bmp"));
    strcpy(ImageName[24], GetPathAndName(S, "Pens.bmp"));
    strcpy(ImageName[25], GetPathAndName(S, "Peppers.bmp"));
    strcpy(ImageName[26], GetPathAndName(S, "Rainier.bmp"));
    strcpy(ImageName[27], GetPathAndName(S, "Sailing.bmp"));
    strcpy(ImageName[28], GetPathAndName(S, "Sun.bmp"));
    strcpy(ImageName[29], GetPathAndName(S, "Sunrise.bmp"));
    strcpy(ImageName[30], GetPathAndName(S, "Yacht.bmp"));
    strcpy(ImageName[31], GetPathAndName(S, "Zelda.bmp"));

    return ImageIndex + 1;
  }

  private StringBuffer GetPathAndName(StringBuffer result, String name) {
    result.setLength(0);
    result.append(PATH_TO_IMAGES);
    result.append(name);
    return result;
  }

  public int LoadBMP() {
    BufferedImage image;
    try {
      lastLoaded = ImageName[ImageIndex].toString();
      image = ImageIO.read(new File(ImageName[ImageIndex].toString()));
    } catch (IOException e) {
      e.printStackTrace();
      return 0;
    }

    W = image.getWidth();
    H = image.getHeight();

    int x, y;

    InputImageData = new Vector<Vector<Integer>>();

    Raster raster = image.getRaster();

    for (x = 0; x < W; x++) {
      InputImageData.add(new Vector<>());
      for (y = 0; y < H; y++) {
        int sample = raster.getSample(x, y, 0);
        InputImageData.get(x).add(sample);
      }
    }

    return 1;
  }

  public double ReturnEntropy() {
    return AuxCompFunctions.CalculateEntropy(
        AuxCompFunctions.DoMatrixStatistic(H, W, InputImageData));
  }

  public Vector<Vector<Integer>> ReturnImageData() {
    return InputImageData;
  }

  public int ReturnNextBatchData(final Vector<Vector<Integer>> IB) {
    if (BatchIndex < NO_OF_BATCH_IMAGES) {

      BufferedImage image;
      try {
        lastLoaded = BatchImageName[BatchIndex].toString();
        image = ImageIO.read(new File(BatchImageName[BatchIndex].toString()));
      } catch (IOException e) {
        e.printStackTrace();
        return 0;
      }

      W = image.getWidth();
      H = image.getHeight();

      int x, y;

      InputImageData = new Vector<Vector<Integer>>();

      Raster raster = image.getRaster();

      for (x = 0; x < W; x++) {
        InputImageData.add(new Vector<>());
        for (y = 0; y < H; y++) {
          int sample = raster.getSample(x, y, 0);
          InputImageData.get(x).add(sample);
        }
      }

      IB.addAll(InputImageData);
      BatchIndex++;
      return 1;
    }
    return 0;
  }

  public int ReturnNoOfBatches() {
    return NO_OF_BATCH_IMAGES;
  }
}
