#pragma once
#include <vector>

using namespace std;

class KMTFInt {
  private:
    int lowerBound;
    int upperBound;
    int kMTF;
    int FirstEl;
    vector<int> ABC;
    vector<int> O;

    void SetABC();
    int GetPosition(int v);
    void MoveAToFront(vector<int> A);
    void MoveAToFrontOpt(vector<int>& A, std::vector<bool>& lut);
    void MoveToFront(int p);
    void PrintABC(int v);

  public:
    KMTFInt();
    void Init(int k, int l, int h, int first);

    vector<int> DoKMTFInt(vector<int> I);
    vector<int> DoKMTFIntOpt(vector<int> I);
    vector<int> DoDeKMTFInt(vector<int> I);
    vector<int> DoDeKMTFIntOpt(vector<int> I);
};
